---

global:
  tlsDisable: {{ (not kubernetes_charts_vault_tls | bool) | lower }}

injector:
  enabled: false

server:
  dataStorage:
    size: {{ kubernetes_charts_vault_storage_size }}
    mountPath: "/vault/data"
{% if kubernetes_charts_vault_storage_class is defined %}
    storageClass: "{{ kubernetes_charts_vault_storage_class }}"
{% endif %}

{% if kubernetes_charts_vault_ha | bool %}
  ha:
    enabled: true
    replicas: {{ kubernetes_charts_vault_nodes | int }}
    
    raft:
      enabled: true
      setNodeId: true

      config: |
        ui = {{ kubernetes_charts_vault_ui | bool | lower }}

        listener "tcp" {
          address = "[::]:8200"
          cluster_address = "[::]:8201"
          tls_disable = {{ (not kubernetes_charts_vault_tls | bool) | lower }}

{% if kubernetes_charts_vault_tls | bool %}
          tls_cert_file = "/vault/userconfig/vault-secret/vault.crt"
          tls_key_file  = "/vault/userconfig/vault-secret/vault.key"
          tls_client_ca_file = "/vault/userconfig/vault-secret/vault.ca"
{% endif %}
        }

        storage "raft" {
          path = "/vault/data"

{% for vault_id in range(kubernetes_charts_vault_nodes | int) %}
          retry_join {
            leader_api_addr = "{{ kubernetes_charts_vault_protocol }}://vault-{{ vault_id }}.vault-internal:8200"
{% if kubernetes_charts_vault_tls | bool %}
            leader_ca_cert_file = "/vault/userconfig/vault-secret/vault.ca"
            leader_client_cert_file = "/vault/userconfig/vault-secret/vault.crt"
            leader_client_key_file = "/vault/userconfig/vault-secret/vault.key"
{% endif %}
          }
{% endfor %}
        }
{% else %}
  standalone:
    enabled: true

    config: |
      ui = {{ kubernetes_charts_vault_ui | bool | lower }}

      listener "tcp" {
        address = "[::]:8200"
        cluster_address = "[::]:8201"
        tls_disable = {{ (not kubernetes_charts_vault_tls | bool) | lower }}

{% if kubernetes_charts_vault_tls | bool %}
        tls_cert_file = "/vault/userconfig/vault-secret/vault.crt"
        tls_key_file  = "/vault/userconfig/vault-secret/vault.key"
        tls_client_ca_file = "/vault/userconfig/vault-secret/vault.ca"
{% endif %}
      }

      storage "file" {
        path = "/vault/data"
      }
{% endif %}

{% if kubernetes_charts_vault_tls | bool %}
  extraVolumes:
  - type: secret
    name: vault-secret

  extraEnvironmentVars:
    VAULT_CACERT: /vault/userconfig/vault-secret/vault.ca
{% endif %}
